searchData={"items":[{"type":"module","title":"Superls","doc":"A multi volumes files indexer and search engine CLI (elixir, Linux).","ref":"Superls.html"},{"type":"module","title":"Indexing - Superls","doc":"`superls` analyzes the filenames of a volume, extracts the filename tags and other file attributes such as size, date and builds an index for the volume.\n\n  Unless a store name is given (-s), all volume indexes are stored in the `default` store folder.\n\n  Stores are saved compressed and optionally password encrypted.\n\n  The following command creates an index of /path/to/my/files in the `default` store :\n\n```bash\nsuperls archive /path/to/my/files\n```\nor on store `mystore` with stdin password encryption :\n\n```bash\nsuperls archive /path/to/my/files -s mystore -p\n```","ref":"Superls.html#module-indexing"},{"type":"module","title":"Search - Superls","doc":"The command to search tags in the `default` store with the CLI is :\n\n```bash\nsuperls search\n```\nAn interactive shell asks for commands like query by a list of tags, a string separated by space. A tag can be incomplete. \nThe result is a list of matched files.","ref":"Superls.html#module-search"},{"type":"module","title":"Other CLI commands - Superls","doc":"For help, getting stores commands ...  :\n\n```bash\nsuperls\n```","ref":"Superls.html#module-other-cli-commands"},{"type":"module","title":"What is parsed ? - Superls","doc":"`superls` tokenizes the filenames with the following delimiters :\n```elixir\n  \",\",  \"_\",  \"-\",  \".\",  \"*\",  \"/\",\n  \"(\",  \")\",  \":\",  \"|\",  \"\\\"\",  \"[\",  \"]\",\n  \"{\",  \"}\",  \"\\t\",  \"\\n\",  \" \n  ```\n\nCollected tags are grouped with some files attributes, currently: size, mtime, atime. \n\nTags and file attributes constitute the index entry for the file.","ref":"Superls.html#module-what-is-parsed"},{"type":"module","title":"Discarding files and tags from indexing - Superls","doc":"Files with an extension present in `./priv/banned_file_ext` are not indexed.\n\nTags present in `./priv/banned_tags` are not indexed.","ref":"Superls.html#module-discarding-files-and-tags-from-indexing"},{"type":"module","title":"Advanced search - Superls","doc":"#### jaro search\n#### by size search","ref":"Superls.html#module-advanced-search"},{"type":"function","title":"Superls.decrypt/2","doc":"Returns `decrypted` from `term` with `passwd`","ref":"Superls.html#decrypt/2"},{"type":"function","title":"Superls.encrypt/2","doc":"Returns `encrypted` from `term` with `passwd`","ref":"Superls.html#encrypt/2"},{"type":"function","title":"Superls.gets/2","doc":"","ref":"Superls.html#gets/2"},{"type":"function","title":"Superls.halt/1","doc":"interrupt flow with the stores_pathmessage `mg`","ref":"Superls.html#halt/1"},{"type":"type","title":"Superls.store/0","doc":"","ref":"Superls.html#t:store/0"},{"type":"function","title":"Superls.string_to_numeric/1","doc":"","ref":"Superls.html#string_to_numeric/1"},{"type":"module","title":"Superls.MergedIndex","doc":"iex> mi = Superls.Store.get_merged_index_from_store(\"test\",\"\"= _passwd)\n    `[{\"/media/vol1\",\n       %{\n         \"ACTION\" => %{\n           \"filename1 ACTION\" => %{\n             size: 0,\n             dir: \".\",\n             atime: 1_742_806_274,\n             mtime: 1_742_806_274\n           },\n           \"filename2 ACTION\" => %{\n             size: 0,\n             dir: \".\",\n             atime: 1_742_806_274,\n            mtime: 1_742_806_274\n           }\n         },\n         \"filename1\" => %{\n           \"filename1 ACTION\" => %{\n            size: 0,\n            dir: \".\",\n            atime: 1_742_806_274,\n            mtime: 1_742_806_274\n          }\n         },\n         \"filename2\" => %{\n           \"filename2 ACTION\" => %{\n             size: 0,\n             dir: \".\",\n             atime: 1_742_806_274,\n             mtime: 1_742_806_274\n           }\n         }\n       }},\n     {\"/media/vol2 ⭐️\",\n       %{\n         \"JAZZ\" => %{\n           \"filename3 JAZZ\" => %{\n             size: 0,\n             dir: \".\",\n             atime: 1_742_806_274,\n             mtime: 1_742_806_274\n          }\n        },\n         \"filename3\" => %{\n            \"filename3 JAZZ\" => %{\n               size: 0,\n               dir: \".\",\n              atime: 1_742_806_274,\n              mtime: 1_742_806_274\n         }\n        }\n      }}]`\n\nThis sample show a merged index from 2 volumes, `/media/vol1` and `/media/vol2 ⭐️`.\n\nEach index holds a map of tags.\n\nLast, each tag references all files that contain the tag.\n\nThis merged index is stored encrypted or not on the local filesystem.","ref":"Superls.MergedIndex.html"},{"type":"type","title":"Superls.MergedIndex.file_entry/0","doc":"","ref":"Superls.MergedIndex.html#t:file_entry/0"},{"type":"type","title":"Superls.MergedIndex.file_name/0","doc":"","ref":"Superls.MergedIndex.html#t:file_name/0"},{"type":"function","title":"Superls.MergedIndex.files_index_from_tags/1","doc":"Returns a list of files referenced by the merged index tags by volume.","ref":"Superls.MergedIndex.html#files_index_from_tags/1"},{"type":"function","title":"Superls.MergedIndex.flatten_files_vol/1","doc":"Returns a volume-flattened files list.","ref":"Superls.MergedIndex.html#flatten_files_vol/1"},{"type":"function","title":"Superls.MergedIndex.get_num_tags/1","doc":"Count the tags","ref":"Superls.MergedIndex.html#get_num_tags/1"},{"type":"function","title":"Superls.MergedIndex.metrics/2","doc":"return the metrics as a map restricted to `limit_tags_count` most used tags.","ref":"Superls.MergedIndex.html#metrics/2"},{"type":"type","title":"Superls.MergedIndex.relative_path/0","doc":"","ref":"Superls.MergedIndex.html#t:relative_path/0"},{"type":"function","title":"Superls.MergedIndex.search_bydate/4","doc":"Returns a list of files sorted by the oldness `cmd` from the date `date` and limited in size by `ndays`.\n      iex> mi |> MergedIndex.search_bydate(\"xo\", \"10.03.31\", 50)\n      [..]","ref":"Superls.MergedIndex.html#search_bydate/4"},{"type":"function","title":"Superls.MergedIndex.search_duplicated_tags/1","doc":"Returns a map containing best `jaro` distances as a numerical key and their associated matching files.","ref":"Superls.MergedIndex.html#search_duplicated_tags/1"},{"type":"function","title":"Superls.MergedIndex.search_oldness/3","doc":"Returns a list of files sorted by the oldness `cmd` and limited in size by `nentries`.\n      iex> mi |> MergedIndex.search_oldness(\"xo\", 50)\n      [..]","ref":"Superls.MergedIndex.html#search_oldness/3"},{"type":"function","title":"Superls.MergedIndex.search_similar_size/1","doc":"Returns a sorted list of files with similar `size`.","ref":"Superls.MergedIndex.html#search_similar_size/1"},{"type":"opaque","title":"Superls.MergedIndex.t/0","doc":"","ref":"Superls.MergedIndex.html#t:t/0"},{"type":"type","title":"Superls.MergedIndex.tag/0","doc":"","ref":"Superls.MergedIndex.html#t:tag/0"},{"type":"type","title":"Superls.MergedIndex.tag_entry/0","doc":"","ref":"Superls.MergedIndex.html#t:tag_entry/0"},{"type":"function","title":"Superls.MergedIndex.tag_freq/1","doc":"Return a map of {`tag` => `count`}.","ref":"Superls.MergedIndex.html#tag_freq/1"},{"type":"type","title":"Superls.MergedIndex.tags/0","doc":"","ref":"Superls.MergedIndex.html#t:tags/0"},{"type":"opaque","title":"Superls.MergedIndex.vol_tags/0","doc":"","ref":"Superls.MergedIndex.html#t:vol_tags/0"},{"type":"type","title":"Superls.MergedIndex.volume/0","doc":"","ref":"Superls.MergedIndex.html#t:volume/0"},{"type":"module","title":"Superls.Store","doc":"Store access facilities.","ref":"Superls.Store.html"},{"type":"function","title":"Superls.Store.archive/3","doc":"Create a `merged_index` from `media_path`, `store` and `passwd`.","ref":"Superls.Store.html#archive/3"},{"type":"function","title":"Superls.Store.cache_path/0","doc":"the cache `path`","ref":"Superls.Store.html#cache_path/0"},{"type":"function","title":"Superls.Store.cache_store_path/1","doc":"Returns the `store` cache `path`","ref":"Superls.Store.html#cache_store_path/1"},{"type":"function","title":"Superls.Store.check_password/2","doc":"verify `passwd`.","ref":"Superls.Store.html#check_password/2"},{"type":"function","title":"Superls.Store.encode_digest_uri/1","doc":"Returns the `digest` from a `vol_path`","ref":"Superls.Store.html#encode_digest_uri/1"},{"type":"function","title":"Superls.Store.get_merged_index_from_store/2","doc":"get `merged_index` from `store`.","ref":"Superls.Store.html#get_merged_index_from_store/2"},{"type":"function","title":"Superls.Store.list_indexes/2","doc":"Get the `indexes` list from `store` and `password`.","ref":"Superls.Store.html#list_indexes/2"},{"type":"function","title":"Superls.Store.list_stores/0","doc":"Get the `stores` list.","ref":"Superls.Store.html#list_stores/0"},{"type":"function","title":"Superls.Store.maybe_create_cache_path/0","doc":"","ref":"Superls.Store.html#maybe_create_cache_path/0"},{"type":"function","title":"Superls.Store.maybe_create_dir/1","doc":"Maybe creates and returns the `store` cache `path`","ref":"Superls.Store.html#maybe_create_dir/1"},{"type":"type","title":"Superls.Store.store/0","doc":"","ref":"Superls.Store.html#t:store/0"},{"type":"function","title":"Superls.Store.volume_path_from_digests/2","doc":"Get the `volume_path` list from `store` and `password`.","ref":"Superls.Store.html#volume_path_from_digests/2"},{"type":"module","title":"Superls.StrFmt","doc":"```elixir\niex> StrFmt.to_string [{12000, :sizeb, [:bright]}]\n\"\u001B[1m  11.7K\u001B[0m\"\n```\n\nor composable form :\n\n```elixir\niex> [ [str_fmt1, str_fmt2], \n       str_fmt3\n     ] |> StrFmt.to_string()\n```\n\nstr_fmt_unit                        | output for a 8 columns terminal\n:---------------------------------- | :---------\n`\"abc\"`                             | `\"abc\"`\n`[{\"abc\", :str, [:blue]}]`          | `\"\u001B[34mabc\u001B[0m\"`\n`[{123, :str, [:blue]}]`            | `\"\u001B[34m123\u001B[0m\"`\n`[{12000, :sizeb, []}]`             | `\"  11.7K\"`  # could be B, K, M and G.\n`[{1696153262, :date, [:blue]}]`    | `\"\u001B[34m2023-10-01\u001B[0m\"`\n`[{1696153262, :datetime, []}]`     | `\"23-10-01 09:41:02\"`\n`[{\"9char-str\", {:scr,50}, []}]`    | `\"9..r\"`     # 50% of 9 chars screen\n`[{\"9char-str\", :scr, []}]`         | `\"9ch..str\"` # equiv. of {:scr, 100}\n`[{\"foo_\", :padr, []}]`             | `\"foo_____\"`\n`[{\"_\", :padl, [:red]}]`            | `\"\u001B[31m_____\u001B[0m\"`","ref":"Superls.StrFmt.html"},{"type":"function","title":"Superls.StrFmt.ncols/0","doc":"Returns the terminal number of columns.","ref":"Superls.StrFmt.html#ncols/0"},{"type":"function","title":"Superls.StrFmt.puts/1","doc":"puts(fmt) convenience for `to_string(fmt) |> IO.puts()`","ref":"Superls.StrFmt.html#puts/1"},{"type":"type","title":"Superls.StrFmt.str_fmt_unit/0","doc":"","ref":"Superls.StrFmt.html#t:str_fmt_unit/0"},{"type":"type","title":"Superls.StrFmt.t/0","doc":"","ref":"Superls.StrFmt.html#t:t/0"},{"type":"function","title":"Superls.StrFmt.text_length/1","doc":"","ref":"Superls.StrFmt.html#text_length/1"},{"type":"function","title":"Superls.StrFmt.to_string/1","doc":"Format the `str_fmt` into a string.\n\n    iex> StrFmt.to_string [{12000, :sizeb, [:bright]}]\n    \"\u001B[1m  11.7K\u001B[0m\"\n\nThe transformations are :\n\n- colors\n\n  see `IO.ANSI`.\n- padding to a ncols terminal\n\n  `padr`  `padl`     \n- human readable bytes B, K, M, G\n\n  `sizeb`\n- shorten txt, may add ellipsis if txt length > ncols\n\n  `scr`  \n- shorten percent txt, may add ellipsis if txt length > 44% of ncols\n\n  `{scr, 44}`  \n- human readable date, datetime (posix)\n\n  `date` `datetime`\n- basic types interpolation\n\n  `str`\n- newline\n\n  `\"\n\"`","ref":"Superls.StrFmt.html#to_string/1"},{"type":"module","title":"Superls.Tag","doc":"Tokenize a media path.","ref":"Superls.Tag.html"},{"type":"function","title":"Superls.Tag.extract_tokens/1","doc":"extract all tokens including dates `10.16.16` and times `16:57` tokens.","ref":"Superls.Tag.html#extract_tokens/1"},{"type":"function","title":"Superls.Tag.index_media_path/1","doc":"Tokenize `media_path` volume and returns its `index`.","ref":"Superls.Tag.html#index_media_path/1"},{"type":"function","title":"Superls.Tag.search_matching_tags/2","doc":"Search all tags in `merged_index` that match the `search_str`,\n\nReturns {`matches`, `query_tags`}.","ref":"Superls.Tag.html#search_matching_tags/2"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}